Index: issm/trunk/src/c/parallel/ProcessResults.cpp
===================================================================
--- issm/trunk/src/c/parallel/ProcessResults.cpp	(revision 3588)
+++ issm/trunk/src/c/parallel/ProcessResults.cpp	(revision 3703)
@@ -112,8 +112,8 @@
 	
 	/*some flags needed: */
-	model->FindParam(&dim,"dim");
-	model->FindParam(&ishutter,"ishutter");
-	model->FindParam(&isstokes,"isstokes");
-	model->FindParam(&ismacayealpattyn,"ismacayealpattyn");
+	model->FindParam(&dim,DimEnum);
+	model->FindParam(&ishutter,IsHutterEnum);
+	model->FindParam(&isstokes,IsStokesEnum);
+	model->FindParam(&ismacayealpattyn,IsMacayealPattynEnum);
 
 	/*Recover femmodels first: */
@@ -158,12 +158,12 @@
 				/*ok, 2 dofs, on number of nodes: */
 				if(ismacayealpattyn){
-					fem_dh->parameters->FindParam(&numberofnodes,"numberofnodes");
+					fem_dh->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 					VecToMPISerial(&partition,fem_dh->partition->vector);
-					fem_dh->parameters->FindParam(&yts,"yts");
+					fem_dh->parameters->FindParam(&yts,YtsEnum);
 				}
 				else{
-					fem_dhu->parameters->FindParam(&numberofnodes,"numberofnodes");
+					fem_dhu->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 					VecToMPISerial(&partition,fem_dhu->partition->vector);
-					fem_dhu->parameters->FindParam(&yts,"yts");
+					fem_dhu->parameters->FindParam(&yts,YtsEnum);
 				}
 				vx=(double*)xmalloc(numberofnodes*sizeof(double));
@@ -184,12 +184,12 @@
 					/*ok, 3 dofs, on number of nodes: */
 					if(ismacayealpattyn){
-						fem_dh->parameters->FindParam(&numberofnodes,"numberofnodes");
+						fem_dh->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 						VecToMPISerial(&partition,fem_dh->partition->vector);
-						fem_dh->parameters->FindParam(&yts,"yts");
+						fem_dh->parameters->FindParam(&yts,YtsEnum);
 					}
 					else{
-						fem_dhu->parameters->FindParam(&numberofnodes,"numberofnodes");
+						fem_dhu->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 						VecToMPISerial(&partition,fem_dhu->partition->vector);
-						fem_dhu->parameters->FindParam(&yts,"yts");
+						fem_dhu->parameters->FindParam(&yts,YtsEnum);
 					}
 					vx=(double*)xmalloc(numberofnodes*sizeof(double));
@@ -207,7 +207,7 @@
 				else{
 					/* 4 dofs on number of nodes. discard pressure: */
-					fem_ds->parameters->FindParam(&numberofnodes,"numberofnodes");
+					fem_ds->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 					VecToMPISerial(&partition,fem_ds->partition->vector);
-					fem_ds->parameters->FindParam(&yts,"yts");
+					fem_ds->parameters->FindParam(&yts,YtsEnum);
 					vx=(double*)xmalloc(numberofnodes*sizeof(double));
 					vy=(double*)xmalloc(numberofnodes*sizeof(double));
@@ -252,14 +252,14 @@
 			if(!isstokes){
 				if(ismacayealpattyn){
-					fem_dh->parameters->FindParam(&numberofnodes,"numberofnodes");
+					fem_dh->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 					VecToMPISerial(&partition,fem_dh->partition->vector);
 				}
 				else{
-					fem_dhu->parameters->FindParam(&numberofnodes,"numberofnodes");
+					fem_dhu->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 					VecToMPISerial(&partition,fem_dhu->partition->vector);
 				}
 			}
 			else{
-				fem_ds->parameters->FindParam(&numberofnodes,"numberofnodes");
+				fem_ds->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 				VecToMPISerial(&partition,fem_ds->partition->vector);
 			}
@@ -285,5 +285,5 @@
 			result->GetField(&t_g);
 			VecToMPISerial(&t_g_serial,t_g);
-			fem_t->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_t->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_t->partition->vector);
 
@@ -309,5 +309,5 @@
 			result->GetField(&grad_g);
 			VecToMPISerial(&grad_g_serial,grad_g);
-			fem_c->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_c->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_c->partition->vector);
 
@@ -332,6 +332,6 @@
 			result->GetField(&m_g);
 			VecToMPISerial(&m_g_serial,m_g);
-			fem_t->parameters->FindParam(&numberofnodes,"numberofnodes");
-			fem_t->parameters->FindParam(&yts,"yts");
+			fem_t->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
+			fem_t->parameters->FindParam(&yts,YtsEnum);
 			VecToMPISerial(&partition,fem_t->partition->vector);
 
@@ -356,5 +356,5 @@
 			result->GetField(&h_g);
 			VecToMPISerial(&h_g_serial,h_g);
-			fem_p->parameters->FindParam(&numberofvertices,"numberofvertices");
+			fem_p->parameters->FindParam(&numberofvertices,NumberOfVerticesEnum);
 			VecToMPISerial(&partition,fem_p->partition->vector);
 
@@ -379,5 +379,5 @@
 			result->GetField(&v_g);
 			VecToMPISerial(&v_g_serial,v_g);
-			fem_p->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_p->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_p->partition->vector);
 
@@ -402,5 +402,5 @@
 			result->GetField(&s_g);
 			VecToMPISerial(&s_g_serial,s_g);
-			fem_p->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_p->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_p->partition->vector);
 
@@ -425,5 +425,5 @@
 			result->GetField(&sx_g);
 			VecToMPISerial(&sx_g_serial,sx_g);
-			fem_sl->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_sl->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_sl->partition->vector);
 
@@ -448,5 +448,5 @@
 			result->GetField(&sy_g);
 			VecToMPISerial(&sy_g_serial,sy_g);
-			fem_sl->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_sl->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_sl->partition->vector);
 
@@ -471,5 +471,5 @@
 			result->GetField(&b_g);
 			VecToMPISerial(&b_g_serial,b_g);
-			fem_p->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_p->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_p->partition->vector);
 
@@ -493,5 +493,5 @@
 			/*easy, param_g is of size numberofnodes, on 1 dof, just repartition: */
 			result->GetField(&param_g);
-			fem_dh->parameters->FindParam(&numberofnodes,"numberofnodes");
+			fem_dh->parameters->FindParam(&numberofnodes,NumberOfNodesEnum);
 			VecToMPISerial(&partition,fem_dh->partition->vector);
 
@@ -513,5 +513,5 @@
 		else if(strcmp(result->GetFieldName(),"riftproperties")==0){
 			result->GetField(&riftproperties);
-			fem_dh->parameters->FindParam(&numrifts,"numrifts");
+			fem_dh->parameters->FindParam(&numrifts,NumRiftsEnum);
 			VecToMPISerial(&riftproperties_serial,riftproperties);
 			
@@ -524,5 +524,5 @@
 		else if(strcmp(result->GetFieldName(),"sigma_zz")==0){
 			/*easy, param_g is of size numberofelements, on 1 dof, just repartition: */
-			fem_ds->parameters->FindParam(&numberofelements,"numberofelements");
+			fem_ds->parameters->FindParam(&numberofelements,NumberOfElementsEnum);
 			result->GetField(&sigma_zz);
 			VecToMPISerial(&sigma_zz_serial,sigma_zz);