Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 3845)
+++ issm/trunk/src/c/Makefile.am	(revision 3895)
@@ -836,29 +836,29 @@
 					./OutputRiftsx/OutputRiftsx.h\
 					./OutputRiftsx/OutputRiftsx.cpp\
-					./parallel/diagnostic_core.cpp\
-					./parallel/diagnostic_core_linear.cpp\
-					./parallel/diagnostic_core_nonlinear.cpp\
-					./parallel/convergence.cpp\
-					./parallel/thermal_core.cpp\
-					./parallel/thermal_core_nonlinear.cpp\
-					./parallel/WriteLockFile.cpp\
-					./parallel/control_core.cpp\
-					./parallel/ControlInitialization.cpp\
-					./parallel/ControlRestart.cpp\
-					./parallel/objectivefunctionC.cpp\
-					./parallel/gradjcompute_core.cpp\
-					./parallel/ProcessResults.cpp\
-					./parallel/prognostic_core.cpp\
-					./parallel/prognostic2_core.cpp\
-					./parallel/balancedthickness_core.cpp\
-					./parallel/balancedthickness2_core.cpp\
-					./parallel/balancedvelocities_core.cpp\
-					./parallel/slopecompute_core.cpp\
-					./parallel/slope_core.cpp\
-					./parallel/transient_core.cpp\
-					./parallel/transient_core_2d.cpp\
-					./parallel/transient_core_3d.cpp\
-					./parallel/steadystate_core.cpp\
-					./parallel/OutputResults.cpp\
+					./solutions/diagnostic_core.cpp\
+					./solutions/diagnostic_core_linear.cpp\
+					./solutions/diagnostic_core_nonlinear.cpp\
+					./solutions/convergence.cpp\
+					./solutions/thermal_core.cpp\
+					./solutions/thermal_core_nonlinear.cpp\
+					./solutions/WriteLockFile.cpp\
+					./solutions/control_core.cpp\
+					./solutions/ControlInitialization.cpp\
+					./solutions/ControlRestart.cpp\
+					./solutions/objectivefunctionC.cpp\
+					./solutions/gradjcompute_core.cpp\
+					./solutions/ProcessResults.cpp\
+					./solutions/prognostic_core.cpp\
+					./solutions/prognostic2_core.cpp\
+					./solutions/balancedthickness_core.cpp\
+					./solutions/balancedthickness2_core.cpp\
+					./solutions/balancedvelocities_core.cpp\
+					./solutions/slopecompute_core.cpp\
+					./solutions/slope_core.cpp\
+					./solutions/transient_core.cpp\
+					./solutions/transient_core_2d.cpp\
+					./solutions/transient_core_3d.cpp\
+					./solutions/steadystate_core.cpp\
+					./solutions/OutputResults.cpp\
 					./Bamgx/Bamgx.cpp\
 					./Bamgx/Bamgx.h\
@@ -934,31 +934,31 @@
 LDADD =    ./libpISSM.a $(PETSCLIB)    $(FLIBS)  $(PLAPACKLIB)  $(MUMPSLIB) $(SCALAPACKLIB)  $(BLACSLIB)  $(DAKOTALIB) $(METISLIB) $(BLASLAPACKLIB)  $(MKLLIB) $(MPILIB) $(MATHLIB) $(FORTRANLIB) $(GRAPHICSLIB) libOverload.a
 
-diagnostic_exe_SOURCES = parallel/diagnostic.cpp
+diagnostic_exe_SOURCES = solutions/diagnostic.cpp
 diagnostic_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-steadystate_exe_SOURCES = parallel/steadystate.cpp
+steadystate_exe_SOURCES = solutions/steadystate.cpp
 steadystate_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-thermal_exe_SOURCES = parallel/thermal.cpp
+thermal_exe_SOURCES = solutions/thermal.cpp
 thermal_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-prognostic_exe_SOURCES = parallel/prognostic.cpp
+prognostic_exe_SOURCES = solutions/prognostic.cpp
 prognostic_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-prognostic2_exe_SOURCES = parallel/prognostic2.cpp
+prognostic2_exe_SOURCES = solutions/prognostic2.cpp
 prognostic2_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-balancedthickness_exe_SOURCES = parallel/balancedthickness.cpp
+balancedthickness_exe_SOURCES = solutions/balancedthickness.cpp
 balancedthickness_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-balancedthickness2_exe_SOURCES = parallel/balancedthickness2.cpp
+balancedthickness2_exe_SOURCES = solutions/balancedthickness2.cpp
 balancedthickness2_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-balancedvelocities_exe_SOURCES = parallel/balancedvelocities.cpp
+balancedvelocities_exe_SOURCES = solutions/balancedvelocities.cpp
 balancedvelocities_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-slopecompute_exe_SOURCES = parallel/slopecompute.cpp
+slopecompute_exe_SOURCES = solutions/slopecompute.cpp
 slopecompute_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-transient_exe_SOURCES = parallel/transient.cpp
+transient_exe_SOURCES = solutions/transient.cpp
 transient_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 