Index: issm/trunk/src/c/modules/Qmux/SpawnCoreSerial.cpp
===================================================================
--- issm/trunk/src/c/modules/Qmux/SpawnCoreSerial.cpp	(revision 4057)
+++ issm/trunk/src/c/modules/Qmux/SpawnCoreSerial.cpp	(revision 4058)
@@ -19,5 +19,5 @@
 #include "../../include/include.h"
 
-void SpawnCoreSerial(double* responses, int numresponses, double* variables, char** variables_descriptors,int numvariables, mxArray* modelint counter){
+void SpawnCoreSerial(double* responses, int numresponses, double* variables, char** variables_descriptors,int numvariables, mxArray* femmodel, int counter){
 
 	int i;
@@ -52,5 +52,5 @@
 
 	//call SpwanCore matlab routine.
-	array[0]=model;
+	array[0]=femmodel;
 	array[2]=mxvariables;
 	array[3]=mxvariabledescriptors;
Index: issm/trunk/src/c/solutions/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4058)
@@ -66,9 +66,8 @@
 
 	/*add outputfilename in parameters: */
-	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 	
 	/*get parameters: */
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
 	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
@@ -81,11 +80,9 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		balancedthickness_core(model);
+		balancedthickness_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
-	}
-
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 	}
 	else{
Index: issm/trunk/src/c/solutions/balancedthickness2.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4058)
@@ -68,5 +68,5 @@
 
 	/*add outputfilename in parameters: */
-	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -82,5 +82,5 @@
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 
 	}
Index: issm/trunk/src/c/solutions/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4058)
@@ -22,7 +22,7 @@
 	FILE* fid=NULL;
 	char* inputfilename=NULL;
-	char* outputfilename=NULL;
 	bool   qmu_analysis;
 	char* lockname=NULL;
+	char* outputfilename=NULL;
 	bool  waitonlock=false;
 
@@ -67,9 +67,8 @@
 
 	/*add outputfilename in parameters: */
-	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 	
 	/*get parameters: */
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
 	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
@@ -86,5 +85,5 @@
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 
 	}
Index: issm/trunk/src/c/solutions/prognostic2.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4058)
@@ -36,5 +36,5 @@
 
 	int analyses[1]={Prognostic2AnalysisEnum};
-	int solution_type=Prognosti2cAnalysisEnum;
+	int solution_type=Prognostic2AnalysisEnum;
 
 	MODULEBOOT();
@@ -69,8 +69,7 @@
 	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
-
+	/*get parameters: */
+	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
Index: issm/trunk/src/c/solutions/steadystate.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystate.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/steadystate.cpp	(revision 4058)
@@ -73,8 +73,8 @@
 	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&control_analysis,ControlAnalysisEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	/*get parameters: */
+	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
+	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
Index: issm/trunk/src/c/solutions/thermal.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/thermal.cpp	(revision 4058)
@@ -38,5 +38,5 @@
 
 	int analyses[2]={ThermalAnalysisEnum,MeltingAnalysisEnum};
-	int solution_type=ThermalSolutionEnum;
+	int solution_type=ThermalAnalysisEnum;
 
 	MODULEBOOT();
Index: issm/trunk/src/c/solutions/transient2d.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient2d.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/transient2d.cpp	(revision 4058)
@@ -36,5 +36,5 @@
 
 	int analyses[2]={DiagnosticHorizAnalysisEnum,PrognosticAnalysisEnum};
-	int solution_type=TransientAnalysisEnum;
+	int solution_type=Transient2DAnalysisEnum;
 
 	MODULEBOOT();
@@ -68,5 +68,4 @@
 	/*get parameters: */
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
 	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
@@ -79,5 +78,5 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		transient2d_core(model);
+		transient2d_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	
Index: issm/trunk/src/c/solutions/transient3d.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient3d.cpp	(revision 4057)
+++ issm/trunk/src/c/solutions/transient3d.cpp	(revision 4058)
@@ -36,5 +36,5 @@
 
 	int analyses[8]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,PrognosticAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
-	int solution_type=TransientAnalysisEnum;
+	int solution_type=Transient3DAnalysisEnum;
 
 	MODULEBOOT();
@@ -68,5 +68,4 @@
 	/*get parameters: */
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
 	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
@@ -79,5 +78,5 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		transient3d_core(model);
+		transient3d_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	